clc;
close all


%data window selection for AMLM
start=1;
stop=1;
% ib134_ptg_x140km_fs200 this is fitted data
for i=1:length(ib134_ptg_x140km_fs200)
    if ib134_ptg_x140km_fs200(i)+0.01<ib134_ptg_x140km_fs200(i+1)
        if ib134_ptg_x140km_fs200(i+1)+0.01<ib134_ptg_x140km_fs200(i+2)
            if ib134_ptg_x140km_fs200(i+2)+0.01<ib134_ptg_x140km_fs200(i+3)
%                 if ( ib134_ptg_x140km_fs200(i+3)-ib134_ptg_x140km_fs200(i+2) )>0.01
                    start=i+1;
                    break;
%                 end
            end
        end
    end
end

for i=start:length(ib134_ptg_x140km_fs200)
    if ib134_ptg_x140km_fs200(i)>ib134_ptg_x140km_fs200(i+1)
        if ib134_ptg_x140km_fs200(i+1)>ib134_ptg_x140km_fs200(i+2)
            if ib134_ptg_x140km_fs200(i+2)>ib134_ptg_x140km_fs200(i+3)
%                 if ( ib134_ptg_x140km_fs200(i+2)-ib134_ptg_x140km_fs200(i+3) )>0.01
                    stop=i+10; %max value/peak value
                    disp(stop)
                    break;
%                 end
            end
        end
    end
end

ibtest_ptg_x140km_fs200=ib134_ptg_x140km_fs200(start:stop);
T=time(start:stop);

figure(2)
plot(T,ibtest_ptg_x140km_fs200,'or-','LineWidth',1.0);
hold on
xline((start/2)*0.00001,'k-.','LineWidth',1.0);
grid on
set(gca,'GridLineStyle','-.','GridColor','k','LineWidth',1.0);
box off
title('Selected data for AMLM:ptg-x=140km','Fontname', 'Times New Roman','FontSize',12)
xlabel('Time/s','Fontname', 'Times New Roman','FontSize',12);
ylabel('i_{b(1)34}/kA','Fontname', 'Times New Roman','FontSize',12);
set(gca, 'LooseInset', [0,0,0,0]);
set(gcf,'unit','centimeters','Position',[17 16 14 10]);
%%
i_temp=ibtest_ptg_x140km_fs200;
data=zeros(2,stop-start+1);
data(1,:)=T;
data(1,:)=data(1,:)-data(1,1);
data(2,:)=i_temp-i_temp(1);
t_fit=data(1,:);% time data;
i_fit=data(2,:);% date used for AMLM;
% plot(data(1,:),data(2,:));
%***********Adaptive Multi-step Levenberg-Marquart Method **********%

% error F(x)= Y - A*(1-exp(-B*X)) 

% merit function || F(x) || * || F(x) || = 0

%  J(x) = F'(x)

%********** Input ***************%


x=data(1,:);%time

y=data(2,:);%measured current data ib
%
c1=4;
%
c2=0.25;
%
p0=0.0001;
%
p1=0.5;
%
p2=0.25;
%
p3=0.75;
%
delta=1; 
t=10;

miu=1/100000;
%
miu_min=1/100000000;

n_data=length(x);

n_para=3;

A1=1000;
A2=1000;
B1=2000;


%
J=zeros(n_data,n_para);
for j=1:n_data
  J(j,:)=[ 1, exp(-B1*x(j)), - A2*x(j)*exp(-B1*x(j))];
end


G=J;


F=y-A1-A2*exp(-B1*x);


F_cost=dot(F,F);

 lamda=miu*sqrt( F_cost ).^delta; 

k=1;

s=1;


i=1;


ki(1)=1;

flag=0;


norm_grad=sqrt( dot(G'*F', G'*F') );

while  norm_grad> (1/100000)  &&  k<=100*(n_data+1) 

 
    H=G'*G+lamda*eye(n_para,n_para);
    F=y-A1-A2*exp(-B1*x); % 
    d_k=inv(H)*(G'*F'); 

    %***

    %
 
    F_d_k=y-(A1+d_k(1))-(A2+d_k(2))*exp( - (B1+d_k(3)) *x );
    Ared_k=dot(F,F)-dot(F_d_k,F_d_k  );

    % 
    % 
    F_G_k=F-(G*d_k)'; 
    Pred_k=dot(F,F)-dot(F_G_k,F_G_k);

    %
    r_k=Ared_k/Pred_k;

    if r_k>=p0
        A1=A1+d_k(1);
        A2=A2+d_k(2);
        B1=B1+d_k(3);

    else
        A1=A1;
        A2=A2;
        B1=B1;

    end

    %***
    if r_k>=p1 && s<t
        G=G;
        flag=0; %
    else
        
        for j=1:n_data
            J(j,:)=[ 1, exp(-B1*x(j)), - A2*x(j)*exp(-B1*x(j)) ];
        end
        G=J;
        flag=1; 
    end

    %**
    if r_k<p2
        miu=c1*miu;
    elseif r_k>p3
        miu=max(c2*miu,miu_min);
    else
        miu=miu;
    end

    if r_k>=p1 && s<t
        lamda=lamda;
    else
            
        F=y-A1-A2*exp(-B1*x);
        lamda=miu*sqrt( dot(F,F) ).^delta;
    end

    %
    k=k+1;

    % 
    norm_grad=sqrt( dot(G'*F', G'*F') ); 

    if flag==1
        s=1;
        i=i+1;
        ki(i)=k;
    else
        s=s+1;
    end

end


i_sim=zeros(n_data,1);

for j=1:n_data
   i_sim(j)=A1+A2*exp(-B1*t_fit(j));
end

%%R-squared;
corr_coef = corrcoef(i_fit, i_sim);

% Extract the R-squared value
R_squared = corr_coef(1,2)^2;

A1_ptg_x140km_fs200_34=A1;
A2_ptg_x140km_fs200_34=A2;
B1_ptg_x140km_fs200_34=B1;
R_squared_ptg_x140km_fs200_34=R_squared;
i_AMLM_ptg_x140km_fs200_34= i_sim;
i_Orign_ptg_x140km_fs200_34=i_fit;
t_fit_ptg_x140km_fs200_34=t_fit;

%%
%data used for AMLM
%data window selection
start=1;
stop=1;

for i=1:length(ib143_ptg_x140km_fs200)
    if ib143_ptg_x140km_fs200(i)+0.01<ib143_ptg_x140km_fs200(i+1)
        if ib143_ptg_x140km_fs200(i+1)+0.01<ib143_ptg_x140km_fs200(i+2)
            if ib143_ptg_x140km_fs200(i+2)+0.01<ib143_ptg_x140km_fs200(i+3)
%                 if ( ib143_ptg_x140km_fs200(i+3)-ib143_ptg_x140km_fs200(i+2) )>0.01
                    start=i+1;
                    break;
%                 end
            end
        end
    end
end

for i=start:length(ib143_ptg_x140km_fs200)
    if ib143_ptg_x140km_fs200(i)>ib143_ptg_x140km_fs200(i+1)
        if ib143_ptg_x140km_fs200(i+1)>ib143_ptg_x140km_fs200(i+2)
            if ib143_ptg_x140km_fs200(i+2)>ib143_ptg_x140km_fs200(i+3)
%                 if ( ib143_ptg_x140km_fs200(i+2)-ib143_ptg_x140km_fs200(i+3) )>0.01
                    stop=i+10; %max value/peak value how many data delayed?
                    disp(stop)
                    break;
%                 end
            end
        end
    end
end

ibtest_ptg_x140km_fs200=ib143_ptg_x140km_fs200(start:stop);
T=time(start:stop);
figure(3)
plot(T,ibtest_ptg_x140km_fs200,'ob-','LineWidth',1.0);
%legend('show','Numcolumns',4,'Location','Best');
hold on
xline((start/2)*0.00001,'k-.','LineWidth',1.0);
grid on
set(gca,'GridLineStyle','-.','GridColor','k','LineWidth',1.0);
box off
title('Selected data for AMLM:ptg-x140km','Fontname', 'Times New Roman','FontSize',12)
xlabel('Time/s','Fontname', 'Times New Roman','FontSize',12);
ylabel('i_{b(1)43}/kA','Fontname', 'Times New Roman','FontSize',12);
set(gca, 'LooseInset', [0,0,0,0]);
set(gcf,'unit','centimeters','Position',[32 16 14 10]);
i_temp=ibtest_ptg_x140km_fs200;
data=zeros(2,stop-start+1);
data(1,:)=T;
data(1,:)=data(1,:)-data(1,1);
data(2,:)=i_temp-i_temp(1);
t_fit=data(1,:);% time data;
i_fit=data(2,:);% date used for AMLM;
% plot(data(1,:),data(2,:));
%***********Adaptive Multi-step Levenberg-Marquart Method **********%

x=data(1,:);%time
%
y=data(2,:);%measured current data ib
%
c1=4;
%
c2=0.25;
%
p0=0.0001;
%
p1=0.5;
%
p2=0.25;
%
p3=0.75;
%
delta=1; 
t=10;
miu=1/100000;
%
miu_min=1/100000000;
%
n_data=length(x);
%
n_para=3;


%
A1=1000;
A2=1000;
B1=2000;



J=zeros(n_data,n_para);
for j=1:n_data
  J(j,:)=[ 1, exp(-B1*x(j)), - A2*x(j)*exp(-B1*x(j))]; 
end


G=J;

F=y-A1-A2*exp(-B1*x);

F_cost=dot(F,F);

 lamda=miu*sqrt( F_cost ).^delta; 
 
%
k=1;

s=1;


i=1;

ki(1)=1;

%
flag=0;





norm_grad=sqrt( dot(G'*F', G'*F') );

while  norm_grad> (1/100000)  &&  k<=100*(n_data+1) 

    
    H=G'*G+lamda*eye(n_para,n_para);
    F=y-A1-A2*exp(-B1*x); 
    d_k=inv(H)*(G'*F'); %

   
    F_d_k=y-(A1+d_k(1))-(A2+d_k(2))*exp( - (B1+d_k(3)) *x );
    Ared_k=dot(F,F)-dot(F_d_k,F_d_k  );

 
    F_G_k=F-(G*d_k)'; 
    Pred_k=dot(F,F)-dot(F_G_k,F_G_k);

    % 
    r_k=Ared_k/Pred_k;

    %
    if r_k>=p0
        A1=A1+d_k(1);
        A2=A2+d_k(2);
        B1=B1+d_k(3);

    else
        A1=A1;
        A2=A2;
        B1=B1;

    end

    %**
    if r_k>=p1 && s<t
        G=G;
        flag=0; %
    else
        
        for j=1:n_data
            J(j,:)=[ 1, exp(-B1*x(j)), - A2*x(j)*exp(-B1*x(j)) ];
        end
        G=J;
        flag=1; 
    end

   
    if r_k<p2
        miu=c1*miu;
    elseif r_k>p3
        miu=max(c2*miu,miu_min);
    else
        miu=miu;
    end

    %**
    if r_k>=p1 && s<t
        lamda=lamda;
    else
        %       
        F=y-A1-A2*exp(-B1*x);
        lamda=miu*sqrt( dot(F,F) ).^delta;
    end

    %
    k=k+1;

    
    norm_grad=sqrt( dot(G'*F', G'*F') ); 

    if flag==1
        s=1;
        i=i+1;
        ki(i)=k;
    else
        s=s+1;
    end

end


i_sim=zeros(n_data,1);

for j=1:n_data
   i_sim(j)=A1+A2*exp(-B1*t_fit(j));
end
length(t_fit);
length(i_sim);

%%R-squared;
corr_coef = corrcoef(i_fit, i_sim);

% Extract the R-squared value
R_squared = corr_coef(1,2)^2;

% Array_A1(ii)=A1;
% Array_A2(ii)=A2;
% Array_B1(ii)=B1;
% Array_R_squared(ii)=R_squared;
A1_ptg_x140km_fs200_43=A1;
A2_ptg_x140km_fs200_43=A2;
B1_ptg_x140km_fs200_43=B1;
R_squared_ptg_x140km_fs200_43=R_squared;
i_AMLM_ptg_x140km_fs200_43= i_sim;
i_Orign_ptg_x140km_fs200_43=i_fit;
t_fit_ptg_x140km_fs200_43=t_fit;
%%
clear F F_cost G H j J k ki K ki d_k c1 c2  A1 A2 B1 data delta flag miu miu_min r_k x y start stop p1 p2 p0 p3 s t T
clear n_data n_para Pred_k norm_grad i_sim i_temp F_d_k F_G_k Ared_k corr_coef i i_fit lamda t_fit ans
clear ibtest_ptg_x140km_fs200
%%
figure(4)
plot(t_fit_ptg_x140km_fs200_34*1000,i_AMLM_ptg_x140km_fs200_34,'--','LineWidth',1.0);
% plot(t_fit,i_AMLM(:,i),'DisplayName', ['Zc=' num2str(18+0.5.*i)],'LineWidth',1.0);
% legend('show','Numcolumns',4,'Location','Best');
hold on
plot(t_fit_ptg_x140km_fs200_34*1000,i_Orign_ptg_x140km_fs200_34,'-','LineWidth',1.0);
hold on
grid on
set(gca,'GridLineStyle','-.','GridColor','k','LineWidth',1.0);
box off
title('Relay R_{34}: ptg-x140km','Fontname', 'Times New Roman','FontSize',12)
xlabel('Time(ms)','Fontname', 'Times New Roman','FontSize',12);
ylabel('Backward i_{b(1)34}/kA','Fontname', 'Times New Roman','FontSize',12);
set(gca, 'LooseInset', [0,0,0,0]);
set(gcf,'unit','centimeters','Position',[2 3 14 10]);
% figure(5)
% plot(Array_R_squared(2:2),'o-','LineWidth',1.5);
% %legend('R-squared','Location','best','Fontname', 'Times New Roman','FontSize',12,'Box','off')
% title('R-squared of curve fitting:ptg-x=140km','Fontname', 'Times New Roman','FontSize',12)
% grid on
% set(gca,'GridLineStyle','-.','GridColor','k','LineWidth',1.0);
% box off
% ylim([0.99 1.0])
% set(gca, 'LooseInset', [0,0,0,0]);
% set(gcf,'unit','centimeters','Position',[32 3 14 10]);

%%
figure(5)
plot(t_fit_ptg_x140km_fs200_43*1000,i_AMLM_ptg_x140km_fs200_43,'--','LineWidth',1.0);
% plot(t_fit,i_AMLM(:,i),'DisplayName', ['Zc=' num2str(18+0.5.*i)],'LineWidth',1.0);
% legend('show','Numcolumns',4,'Location','Best');
hold on
plot(t_fit_ptg_x140km_fs200_43*1000,i_Orign_ptg_x140km_fs200_43,'-','LineWidth',1.0);
hold on
grid on
set(gca,'GridLineStyle','-.','GridColor','k','LineWidth',1.0);
box off
title('Relay R_{43}: ptg-x140km','Fontname', 'Times New Roman','FontSize',12)
xlabel('Time(ms)','Fontname', 'Times New Roman','FontSize',12);
ylabel('Backward i_{b(1)43}/kA','Fontname', 'Times New Roman','FontSize',12);
set(gca, 'LooseInset', [0,0,0,0]);
set(gcf,'unit','centimeters','Position',[17 3 14 10]);
% figure(7)
% plot(Array_R_squared(2:2),'o-','LineWidth',1.5);
% %legend('R-squared','Location','best','Fontname', 'Times New Roman','FontSize',12,'Box','off')
% title('R-squared of curve fitting:ptg-x=140km','Fontname', 'Times New Roman','FontSize',12)
% grid on
% set(gca,'GridLineStyle','-.','GridColor','k','LineWidth',1.0);
% box off
% ylim([0.99 1.0])
% set(gca, 'LooseInset', [0,0,0,0]);
% set(gcf,'unit','centimeters','Position',[32 3 14 10]);
%%
% [maxVal, maxRow] = max(Array_R_squared);
% fprintf('Max"R-square": %d\n', maxVal);
% fprintf('Max"Zc"= %d\n', maxRow);
% 
% disp(B1);
% disp(Array_R_squared(2:2))

%%
% Initialize the R_squared_ptp_fs200 variable as an empty matrix

%%
%fault location
if R_squared_ptg_x140km_fs200_34>R_squared_ptg_x140km_fs200_43
    disp('R_squared_34 is larger: use ib1(34)');
    A1_ptg_x140km_fs200=A1_ptg_x140km_fs200_34;
    A2_ptg_x140km_fs200=A2_ptg_x140km_fs200_34;
    B1_ptg_x140km_fs200=B1_ptg_x140km_fs200_34;
    R_squared_ptg_x140km_fs200_final=R_squared_ptg_x140km_fs200_34;
else
    disp('R_squared_43 is larger: use ib1(43)');
    A1_ptg_x140km_fs200=A1_ptg_x140km_fs200_43;
    A2_ptg_x140km_fs200=A2_ptg_x140km_fs200_43;
    B1_ptg_x140km_fs200=B1_ptg_x140km_fs200_43;
    R_squared_ptg_x140km_fs200_final=R_squared_ptg_x140km_fs200_43;
end
disp(['B1 coefficient = ' num2str(1/B1_ptg_x140km_fs200)]);
disp(['R^2= ' num2str(R_squared_ptg_x140km_fs200_final)]);
disp(length(t_fit_ptg_x140km_fs200_43));
disp(length(t_fit_ptg_x140km_fs200_34));

%disp(['R^2 value = [' num2str(R_squared_ptg_x140km_fs200_34) ' ' num2str(R_squared_ptg_x140km_fs200_43) ']']);
%%
tau=5.98503*10^(-7);%s/km;
disp(['Estimated fault location under fault ptg_x140km_fs200 = ' num2str(1/(B1_ptg_x140km_fs200*tau))]);